# CLI

## Команда `run`

Запускает бенчмарки по указанному файлу, имени класса или директории.

```bash
benchos run [OPTIONS] [FILE]
```

### Опции

| Опция | Описание | Пример |
| --- | --- | --- | 
| `--iterationCount` | Количество измерительных итераций | `--iterationCount 10` |
| `--iterationTime` | Минимальное время выполнения одной итерации (мс) | `--iterationTime 500` |
| `--warmupCount` | Количество прогревочных итераций | `--warmupCount 10` |
| `--invocationCount` | Количество вызовов метода за итерацию | `--invocationCount 100` |
| `--runtime` | Версии OneScript через запятую (current, stable, dev, x.x.x). | `--runtime dev,stable` |
| `--throughput` | Стратегия выполнения [`ПропускнаяСпособность`](СредаВыполнения.md#пропускнаяспособность) | |
| `--coldstart` | Стратегия выполнения [`ХолодныйЗапуск`](СредаВыполнения.md#холодныйзапуск) | |
| `-m`, `--memory` | Включить [мониторинг использования памяти](МониторингПамяти.md) | |
| `-e`, `--exporters` | Форматы [экспорта результатов](ЭкспортРезультатов.md) (`md`, `json`, `xml`, `html`) | `-e json,xml` |
| `-a`, `--artifacts` | Каталог для сохранения результатов | `-a path/to/file` |
| `-r`, `--recursive` | Рекурсивный поиск в поддиректориях | |
| `-c`, `--config` | Файл конфигурации бенчмарков в формате JSON | `-c path/to/config.json` |

## Примеры

```bash
# Запуск по имени класса (файл МойКласс.os должен существовать в текущей директории)
benchos run МойКласс

# Запуск по имени файла в текущей директории
benchos run МойКласс.os

# Запуск по абсолютному пути
benchos run /path/to/МойКласс.os

# Запуск всех бенчмарков в директории
benchos run /path/to/benchmarks

# Запуск всех бенчмарков в директории, включая вложенные каталоги
benchos run -r /path/to/benchmarks

# Рекурсивный запуск с мониторингом памяти и экспортом в JSON
benchos run -r -m -e json ./benchmarks/
```